import { IParticleImage, IColor, ICoordinates, IOpacity, ISize, IVelocity } from "../utils/interfaces";
import { Container } from "./container";
import { ShapeType } from "../utils/enums";
export declare class Particle {
    radius: number;
    size: ISize;
    position: ICoordinates;
    offset: ICoordinates;
    color: IColor;
    opacity: IOpacity;
    velocity: IVelocity;
    initialVelocity: IVelocity;
    shape?: ShapeType;
    img?: IParticleImage;
    opacity_bubble?: number;
    text?: string;
    private readonly container;
    private readonly updater;
    private readonly bubbler;
    private readonly repulser;
    private readonly drawer;
    constructor(container: Container, position?: ICoordinates);
    draw(): void;
    checkOverlap(position?: ICoordinates): void;
    grab(): void;
    bubble(): void;
    repulse(): void;
    link(p2: Particle): void;
    attract(p2: Particle): void;
    bounce(p2: Particle): void;
    move(delta: number): void;
    moveParallax(): void;
    updateOpacity(): void;
    updateSize(): void;
    fixOutOfCanvasPosition(): void;
    updateOutMode(): void;
    private calcPosition;
    private calcVelocity;
    private getVelBase;
    private getColor;
}
